Index: /branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.cpp
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1464)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.cpp	(revision 1465)
@@ -2975,33 +2942,33 @@
  * \returns Bool
  */
-Bool TComDataCU::xAddMVPCandOrder( AMVPInfo* pInfo, RefPicList eRefPicList, Int iRefIdx, UInt uiPartUnitIdx, MVP_DIR eDir )
-{
-  TComDataCU* pcTmpCU = NULL;
-  UInt uiIdx;
+Bool TComDataCU::xAddMVPCandWithScaling( AMVPInfo &info, const RefPicList eRefPicList, const Int iRefIdx, const UInt uiPartUnitIdx, const MVP_DIR eDir ) const
+{
+  const TComDataCU* neibCU = NULL;
+  UInt neibPUPartIdx;
   switch( eDir )
   {
   case MD_LEFT:
     {
-      pcTmpCU = getPULeft(uiIdx, uiPartUnitIdx);
+      neibCU = getPULeft(neibPUPartIdx, uiPartUnitIdx);
       break;
     }
   case MD_ABOVE:
     {
-      pcTmpCU = getPUAbove(uiIdx, uiPartUnitIdx);
+      neibCU = getPUAbove(neibPUPartIdx, uiPartUnitIdx);
       break;
     }
   case MD_ABOVE_RIGHT:
     {
-      pcTmpCU = getPUAboveRight(uiIdx, uiPartUnitIdx);
+      neibCU = getPUAboveRight(neibPUPartIdx, uiPartUnitIdx);
       break;
     }
   case MD_BELOW_LEFT:
     {
-      pcTmpCU = getPUBelowLeft(uiIdx, uiPartUnitIdx);
+      neibCU = getPUBelowLeft(neibPUPartIdx, uiPartUnitIdx);
       break;
     }
   case MD_ABOVE_LEFT:
     {
-      pcTmpCU = getPUAboveLeft(uiIdx, uiPartUnitIdx);
+      neibCU = getPUAboveLeft(neibPUPartIdx, uiPartUnitIdx);
       break;
     }
@@ -3012,44 +2979,29 @@
   }
 
-  if ( pcTmpCU == NULL )
+  if ( neibCU == NULL )
   {
     return false;
   }
 
-  RefPicList eRefPicList2nd = REF_PIC_LIST_0;
-  if(       eRefPicList == REF_PIC_LIST_0 )
-  {
-    eRefPicList2nd = REF_PIC_LIST_1;
-  }
-  else if ( eRefPicList == REF_PIC_LIST_1)
-  {
-    eRefPicList2nd = REF_PIC_LIST_0;
-  }
-
-  Int iCurrPOC = m_pcSlice->getPOC();
-  Int iCurrRefPOC = m_pcSlice->getRefPic( eRefPicList, iRefIdx)->getPOC();
-  Int iNeibPOC = iCurrPOC;
-  Int iNeibRefPOC;
-  Bool bIsCurrRefLongTerm = m_pcSlice->getRefPic( eRefPicList, iRefIdx)->getIsLongTerm();
-  Bool bIsNeibRefLongTerm = false;
-
-  //---------------  V1 (END) ------------------//
-  if( pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) >= 0)
-  {
-    iNeibRefPOC = pcTmpCU->getSlice()->getRefPOC( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) );
-    TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList)->getMv(uiIdx);
-    TComMv rcMv;
-
-    bIsNeibRefLongTerm = pcTmpCU->getSlice()->getRefPic( eRefPicList, pcTmpCU->getCUMvField(eRefPicList)->getRefIdx(uiIdx) )->getIsLongTerm();
-    if ( bIsCurrRefLongTerm == bIsNeibRefLongTerm )
-    {
-      if ( bIsCurrRefLongTerm || bIsNeibRefLongTerm )
-      {
-        rcMv = cMvPred;
-      }
-      else
-      {
-        Int iScale = xGetDistScaleFactor( iCurrPOC, iCurrRefPOC, iNeibPOC, iNeibRefPOC );
-        if ( iScale == 4096 )
+  const RefPicList eRefPicList2nd = (eRefPicList == REF_PIC_LIST_0) ? REF_PIC_LIST_1 : REF_PIC_LIST_0;
+
+  const Int  currPOC            = m_pcSlice->getPOC();
+  const Int  currRefPOC         = m_pcSlice->getRefPic( eRefPicList, iRefIdx)->getPOC();
+  const Bool bIsCurrRefLongTerm = m_pcSlice->getRefPic( eRefPicList, iRefIdx)->getIsLongTerm();
+  const Int  neibPOC            = currPOC;
+
+  for(Int predictorSource=0; predictorSource<2; predictorSource++) // examine the indicated reference picture list, then if not available, examine the other list.
+  {
+    const RefPicList eRefPicListIndex = (predictorSource==0) ? eRefPicList : eRefPicList2nd;
+    const Int        neibRefIdx       = neibCU->getCUMvField(eRefPicListIndex)->getRefIdx(neibPUPartIdx);
+    if( neibRefIdx >= 0)
+    {
+      const Bool bIsNeibRefLongTerm = neibCU->getSlice()->getRefPic( eRefPicListIndex, neibRefIdx )->getIsLongTerm();
+
+      if ( bIsCurrRefLongTerm == bIsNeibRefLongTerm )
+      {
+        const TComMv &cMvPred = neibCU->getCUMvField(eRefPicListIndex)->getMv(neibPUPartIdx);
+        TComMv rcMv;
+        if ( bIsCurrRefLongTerm /* || bIsNeibRefLongTerm*/ )
         {
           rcMv = cMvPred;
@@ -3057,78 +3009,48 @@
         else
         {
-          rcMv = cMvPred.scaleMv( iScale );
+          const Int neibRefPOC = neibCU->getSlice()->getRefPOC( eRefPicListIndex, neibRefIdx );
+          const Int scale      = xGetDistScaleFactor( currPOC, currRefPOC, neibPOC, neibRefPOC );
+          if ( scale == 4096 )
+          {
+            rcMv = cMvPred;
+          }
+          else
+          {
+            rcMv = cMvPred.scaleMv( scale );
+          }
         }
-      }
-
-      pInfo->m_acMvCand[ pInfo->iN++] = rcMv;
-      return true;
-    }
-  }
-  //---------------------- V2(END) --------------------//
-  if( pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) >= 0)
-  {
-    iNeibRefPOC = pcTmpCU->getSlice()->getRefPOC( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) );
-    TComMv cMvPred = pcTmpCU->getCUMvField(eRefPicList2nd)->getMv(uiIdx);
-    TComMv rcMv;
-
-    bIsNeibRefLongTerm = pcTmpCU->getSlice()->getRefPic( eRefPicList2nd, pcTmpCU->getCUMvField(eRefPicList2nd)->getRefIdx(uiIdx) )->getIsLongTerm();
-    if ( bIsCurrRefLongTerm == bIsNeibRefLongTerm )
-    {
-      if ( bIsCurrRefLongTerm || bIsNeibRefLongTerm )
-      {
-        rcMv = cMvPred;
-      }
-      else
-      {
-        Int iScale = xGetDistScaleFactor( iCurrPOC, iCurrRefPOC, iNeibPOC, iNeibRefPOC );
-        if ( iScale == 4096 )
-        {
-          rcMv = cMvPred;
-        }
-        else
-        {
-          rcMv = cMvPred.scaleMv( iScale );
-        }
-      }
-
-      pInfo->m_acMvCand[ pInfo->iN++] = rcMv;
-      return true;
-    }
-  }
-  //---------------------- V3(END) --------------------//
+
+        info.m_acMvCand[info.iN++] = rcMv;
+        return true;
+      }
+    }
+  }
   return false;
 }
 
-Bool TComDataCU::xGetColMVP( RefPicList eRefPicList, Int ctuRsAddr, Int uiPartUnitIdx, TComMv& rcMv, Int& riRefIdx )
-{
-  UInt uiAbsPartAddr = uiPartUnitIdx;
-
-  RefPicList  eColRefPicList;
-  Int iColPOC, iColRefPOC, iCurrPOC, iCurrRefPOC, iScale;
-  TComMv cColMv;
+Bool TComDataCU::xGetColMVP( const RefPicList eRefPicList, const Int ctuRsAddr, const Int partUnitIdx, TComMv& rcMv, const Int refIdx ) const
+{
+  const UInt absPartAddr = partUnitIdx;
 
   // use coldir.
-  TComPic *pColPic = getSlice()->getRefPic( RefPicList(getSlice()->isInterB() ? 1-getSlice()->getColFromL0Flag() : 0), getSlice()->getColRefIdx());
-  TComDataCU *pColCtu = pColPic->getCtu( ctuRsAddr );
-  if(pColCtu->getPic()==0||pColCtu->getPartitionSize(uiPartUnitIdx)==NUMBER_OF_PART_SIZES)
+  const TComPic    * const pColPic = getSlice()->getRefPic( RefPicList(getSlice()->isInterB() ? 1-getSlice()->getColFromL0Flag() : 0), getSlice()->getColRefIdx());
+  const TComDataCU * const pColCtu = pColPic->getCtu( ctuRsAddr );
+  if(pColCtu->getPic()==0 || pColCtu->getPartitionSize(partUnitIdx)==NUMBER_OF_PART_SIZES)
   {
     return false;
   }
-  iCurrPOC = m_pcSlice->getPOC();
-  iColPOC = pColCtu->getSlice()->getPOC();
-
-  if (!pColCtu->isInter(uiAbsPartAddr))
+
+  if (!pColCtu->isInter(absPartAddr))
   {
     return false;
   }
 
-  eColRefPicList = getSlice()->getCheckLDC() ? eRefPicList : RefPicList(getSlice()->getColFromL0Flag());
-
-  Int iColRefIdx = pColCtu->getCUMvField(RefPicList(eColRefPicList))->getRefIdx(uiAbsPartAddr);
+  RefPicList eColRefPicList = getSlice()->getCheckLDC() ? eRefPicList : RefPicList(getSlice()->getColFromL0Flag());
+  Int iColRefIdx            = pColCtu->getCUMvField(RefPicList(eColRefPicList))->getRefIdx(absPartAddr);
 
   if (iColRefIdx < 0 )
   {
     eColRefPicList = RefPicList(1 - eColRefPicList);
-    iColRefIdx = pColCtu->getCUMvField(RefPicList(eColRefPicList))->getRefIdx(uiAbsPartAddr);
+    iColRefIdx = pColCtu->getCUMvField(RefPicList(eColRefPicList))->getRefIdx(absPartAddr);
 
     if (iColRefIdx < 0 )
@@ -3138,19 +3060,15 @@
   }
 
+  const Bool bIsCurrRefLongTerm = m_pcSlice->getRefPic(eRefPicList, refIdx)->getIsLongTerm();
+  const Bool bIsColRefLongTerm  = pColCtu->getSlice()->getIsUsedAsLongTerm(eColRefPicList, iColRefIdx);
+
+  if ( bIsCurrRefLongTerm != bIsColRefLongTerm )
+  {
+    return false;
+  }
+
   // Scale the vector.
-  iColRefPOC = pColCtu->getSlice()->getRefPOC(eColRefPicList, iColRefIdx);
-  cColMv = pColCtu->getCUMvField(eColRefPicList)->getMv(uiAbsPartAddr);
-
-  iCurrRefPOC = m_pcSlice->getRefPic(eRefPicList, riRefIdx)->getPOC();
-
-  Bool bIsCurrRefLongTerm = m_pcSlice->getRefPic(eRefPicList, riRefIdx)->getIsLongTerm();
-  Bool bIsColRefLongTerm = pColCtu->getSlice()->getIsUsedAsLongTerm(eColRefPicList, iColRefIdx);
-
-  if ( bIsCurrRefLongTerm != bIsColRefLongTerm )
-  {
-    return false;
-  }
-
-  if ( bIsCurrRefLongTerm || bIsColRefLongTerm )
+  const TComMv &cColMv = pColCtu->getCUMvField(eColRefPicList)->getMv(absPartAddr);
+  if ( bIsCurrRefLongTerm /*|| bIsColRefLongTerm*/ )
   {
     rcMv = cColMv;
@@ -3158,6 +3076,10 @@
   else
   {
-    iScale = xGetDistScaleFactor(iCurrPOC, iCurrRefPOC, iColPOC, iColRefPOC);
-    if ( iScale == 4096 )
+    const Int currPOC    = m_pcSlice->getPOC();
+    const Int colPOC     = pColCtu->getSlice()->getPOC();
+    const Int colRefPOC  = pColCtu->getSlice()->getRefPOC(eColRefPicList, iColRefIdx);
+    const Int currRefPOC = m_pcSlice->getRefPic(eRefPicList, refIdx)->getPOC();
+    const Int scale      = xGetDistScaleFactor(currPOC, currRefPOC, colPOC, colRefPOC);
+    if ( scale == 4096 )
     {
       rcMv = cColMv;
@@ -3165,5 +3087,5 @@
     else
     {
-      rcMv = cColMv.scaleMv( iScale );
+      rcMv = cColMv.scaleMv( scale );
     }
   }
@@ -3172,4 +3094,5 @@
 }
 
+// Static member
 Int TComDataCU::xGetDistScaleFactor(Int iCurrPOC, Int iCurrRefPOC, Int iColPOC, Int iColRefPOC)
 {
@@ -3191,5 +3114,5 @@
 }
 
-Void TComDataCU::xDeriveCenterIdx( UInt uiPartIdx, UInt& ruiPartIdxCenter )
+Void TComDataCU::xDeriveCenterIdx( UInt uiPartIdx, UInt& ruiPartIdxCenter ) const
 {
   UInt uiPartAddr;
@@ -3486,5 +3409,5 @@
 
 #if N0383_IL_CONSTRAINED_TILE_SETS_SEI
-Bool TComDataCU::isInterLayerReference(UChar uhInterDir, TComMvField& cMvFieldL0, TComMvField& cMvFieldL1)
+Bool TComDataCU::isInterLayerReference(UChar uhInterDir, TComMvField& cMvFieldL0, TComMvField& cMvFieldL1) const
 {
   Bool checkILR = false;
Index: /branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.h
===================================================================
--- /branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.h	(revision 1464)
+++ /branches/SHM-dev/source/Lib/TLibCommon/TComDataCU.h	(revision 1465)
@@ -70,6 +70,6 @@
   // -------------------------------------------------------------------------------------------------------------------
 
-  TComPic*      m_pcPic;              ///< picture class pointer
-  TComSlice*    m_pcSlice;            ///< slice header pointer
+  TComPic*      m_pcPic;                                ///< picture class pointer
+  TComSlice*    m_pcSlice;                              ///< slice header pointer
 
   // -------------------------------------------------------------------------------------------------------------------
@@ -77,16 +77,16 @@
   // -------------------------------------------------------------------------------------------------------------------
 
-  UInt          m_ctuRsAddr;          ///< CTU (also known as LCU) address in a slice (Raster-scan address, as opposed to tile-scan/encoding order).
-  UInt          m_absZIdxInCtu;       ///< absolute address in a CTU. It's Z scan order
-  UInt          m_uiCUPelX;           ///< CU position in a pixel (X)
-  UInt          m_uiCUPelY;           ///< CU position in a pixel (Y)
-  UInt          m_uiNumPartition;     ///< total number of minimum partitions in a CU
-  UChar*        m_puhWidth;           ///< array of widths
-  UChar*        m_puhHeight;          ///< array of heights
-  UChar*        m_puhDepth;           ///< array of depths
-  Int           m_unitSize;           ///< size of a "minimum partition"
+  UInt          m_ctuRsAddr;                            ///< CTU (also known as LCU) address in a slice (Raster-scan address, as opposed to tile-scan/encoding order).
+  UInt          m_absZIdxInCtu;                         ///< absolute address in a CTU. It's Z scan order
+  UInt          m_uiCUPelX;                             ///< CU position in a pixel (X)
+  UInt          m_uiCUPelY;                             ///< CU position in a pixel (Y)
+  UInt          m_uiNumPartition;                       ///< total number of minimum partitions in a CU
+  UChar*        m_puhWidth;                             ///< array of widths
+  UChar*        m_puhHeight;                            ///< array of heights
+  UChar*        m_puhDepth;                             ///< array of depths
+  Int           m_unitSize;                             ///< size of a "minimum partition"
 
 #if SVC_EXTENSION
-  UInt          m_layerId;          ///< layer id
+  UInt          m_layerId;                              ///< layer id
 #if FAST_INTRA_SHVC
   UChar         m_reducedSetIntraModes[NUM_INTRA_MODE-1];
@@ -98,23 +98,23 @@
   // -------------------------------------------------------------------------------------------------------------------
 
-  Bool*          m_skipFlag;           ///< array of skip flags
-  SChar*         m_pePartSize;         ///< array of partition sizes
-  SChar*         m_pePredMode;         ///< array of prediction modes
-  SChar*         m_crossComponentPredictionAlpha[MAX_NUM_COMPONENT]; ///< array of cross-component prediction alpha values
-  Bool*          m_CUTransquantBypass;   ///< array of cu_transquant_bypass flags
-  SChar*         m_phQP;               ///< array of QP values
-  UChar*         m_ChromaQpAdj;        ///< array of chroma QP adjustments (indexed). when value = 0, cu_chroma_qp_offset_flag=0; when value>0, indicates cu_chroma_qp_offset_flag=1 and cu_chroma_qp_offset_idx=value-1
-  UInt           m_codedChromaQpAdj;
-  UChar*         m_puhTrIdx;           ///< array of transform indices
-  UChar*         m_puhTransformSkip[MAX_NUM_COMPONENT];///< array of transform skipping flags
-  UChar*         m_puhCbf[MAX_NUM_COMPONENT];          ///< array of coded block flags (CBF)
-  TComCUMvField  m_acCUMvField[NUM_REF_PIC_LIST_01];    ///< array of motion vectors.
-  TCoeff*        m_pcTrCoeff[MAX_NUM_COMPONENT];       ///< array of transform coefficient buffers (0->Y, 1->Cb, 2->Cr)
+  Bool*         m_skipFlag;                             ///< array of skip flags
+  SChar*        m_pePartSize;                           ///< array of partition sizes
+  SChar*        m_pePredMode;                           ///< array of prediction modes
+  SChar*        m_crossComponentPredictionAlpha[MAX_NUM_COMPONENT]; ///< array of cross-component prediction alpha values
+  Bool*         m_CUTransquantBypass;                   ///< array of cu_transquant_bypass flags
+  SChar*        m_phQP;                                 ///< array of QP values
+  UChar*        m_ChromaQpAdj;                          ///< array of chroma QP adjustments (indexed). when value = 0, cu_chroma_qp_offset_flag=0; when value>0, indicates cu_chroma_qp_offset_flag=1 and cu_chroma_qp_offset_idx=value-1
+  UInt          m_codedChromaQpAdj;
+  UChar*        m_puhTrIdx;                             ///< array of transform indices
+  UChar*        m_puhTransformSkip[MAX_NUM_COMPONENT];  ///< array of transform skipping flags
+  UChar*        m_puhCbf[MAX_NUM_COMPONENT];            ///< array of coded block flags (CBF)
+  TComCUMvField m_acCUMvField[NUM_REF_PIC_LIST_01];     ///< array of motion vectors.
+  TCoeff*       m_pcTrCoeff[MAX_NUM_COMPONENT];         ///< array of transform coefficient buffers (0->Y, 1->Cb, 2->Cr)
 #if ADAPTIVE_QP_SELECTION
-  TCoeff*        m_pcArlCoeff[MAX_NUM_COMPONENT];  // ARL coefficient buffer (0->Y, 1->Cb, 2->Cr)
-  Bool           m_ArlCoeffIsAliasedAllocation;  ///< ARL coefficient buffer is an alias of the global buffer and must not be free()'d
-#endif
-
-  Pel*           m_pcIPCMSample[MAX_NUM_COMPONENT];    ///< PCM sample buffer (0->Y, 1->Cb, 2->Cr)
+  TCoeff*       m_pcArlCoeff[MAX_NUM_COMPONENT];        ///< ARL coefficient buffer (0->Y, 1->Cb, 2->Cr)
+  Bool          m_ArlCoeffIsAliasedAllocation;          ///< ARL coefficient buffer is an alias of the global buffer and must not be free()'d
+#endif
+
+  Pel*          m_pcIPCMSample[MAX_NUM_COMPONENT];      ///< PCM sample buffer (0->Y, 1->Cb, 2->Cr)
 
   // -------------------------------------------------------------------------------------------------------------------
@@ -122,13 +122,13 @@
   // -------------------------------------------------------------------------------------------------------------------
 
-  TComDataCU*   m_pCtuAboveLeft;      ///< pointer of above-left CTU.
-  TComDataCU*   m_pCtuAboveRight;     ///< pointer of above-right CTU.
-  TComDataCU*   m_pCtuAbove;          ///< pointer of above CTU.
-  TComDataCU*   m_pCtuLeft;           ///< pointer of left CTU
+  TComDataCU*   m_pCtuAboveLeft;                        ///< pointer of above-left CTU.
+  TComDataCU*   m_pCtuAboveRight;                       ///< pointer of above-right CTU.
+  TComDataCU*   m_pCtuAbove;                            ///< pointer of above CTU.
+  TComDataCU*   m_pCtuLeft;                             ///< pointer of left CTU
   TComDataCU*   m_apcCUColocated[NUM_REF_PIC_LIST_01];  ///< pointer of temporally colocated CU's for both directions
-  TComMvField   m_cMvFieldA;          ///< motion vector of position A
-  TComMvField   m_cMvFieldB;          ///< motion vector of position B
-  TComMvField   m_cMvFieldC;          ///< motion vector of position C
-  TComMv        m_cMvPred;            ///< motion vector predictor
+  TComMvField   m_cMvFieldA;                            ///< motion vector of position A
+  TComMvField   m_cMvFieldB;                            ///< motion vector of position B
+  TComMvField   m_cMvFieldC;                            ///< motion vector of position C
+  TComMv        m_cMvPred;                              ///< motion vector predictor
 
   // -------------------------------------------------------------------------------------------------------------------
@@ -136,14 +136,14 @@
   // -------------------------------------------------------------------------------------------------------------------
 
-  Bool*         m_pbMergeFlag;        ///< array of merge flags
-  UChar*        m_puhMergeIndex;      ///< array of merge candidate indices
+  Bool*         m_pbMergeFlag;                          ///< array of merge flags
+  UChar*        m_puhMergeIndex;                        ///< array of merge candidate indices
 #if AMP_MRG
   Bool          m_bIsMergeAMP;
 #endif
-  UChar*        m_puhIntraDir[MAX_NUM_CHANNEL_TYPE]; // 0-> Luma, 1-> Chroma
-  UChar*        m_puhInterDir;        ///< array of inter directions
+  UChar*        m_puhIntraDir[MAX_NUM_CHANNEL_TYPE];
+  UChar*        m_puhInterDir;                          ///< array of inter directions
   SChar*        m_apiMVPIdx[NUM_REF_PIC_LIST_01];       ///< array of motion vector predictor candidates
   SChar*        m_apiMVPNum[NUM_REF_PIC_LIST_01];       ///< array of number of possible motion vectors predictors
-  Bool*         m_pbIPCMFlag;         ///< array of intra_pcm flags
+  Bool*         m_pbIPCMFlag;                           ///< array of intra_pcm flags
 
   // -------------------------------------------------------------------------------------------------------------------
@@ -151,9 +151,9 @@
   // -------------------------------------------------------------------------------------------------------------------
 
-  Bool          m_bDecSubCu;          ///< indicates decoder-mode
-  Double        m_dTotalCost;         ///< sum of partition RD costs
-  Distortion    m_uiTotalDistortion;  ///< sum of partition distortion
-  UInt          m_uiTotalBits;        ///< sum of partition bits
-  UInt          m_uiTotalBins;        ///< sum of partition bins
+  Bool          m_bDecSubCu;                            ///< indicates decoder-mode
+  Double        m_dTotalCost;                           ///< sum of partition RD costs
+  Distortion    m_uiTotalDistortion;                    ///< sum of partition distortion
+  UInt          m_uiTotalBits;                          ///< sum of partition bits
+  UInt          m_uiTotalBins;                          ///< sum of partition bins
   SChar         m_codedQP;
   UChar*        m_explicitRdpcmMode[MAX_NUM_COMPONENT]; ///< Stores the explicit RDPCM mode for all TUs belonging to this CU
@@ -161,19 +161,19 @@
 protected:
 
-  /// add possible motion vector predictor candidates
-  Bool          xAddMVPCand           ( AMVPInfo* pInfo, RefPicList eRefPicList, Int iRefIdx, UInt uiPartUnitIdx, MVP_DIR eDir );
-  Bool          xAddMVPCandOrder      ( AMVPInfo* pInfo, RefPicList eRefPicList, Int iRefIdx, UInt uiPartUnitIdx, MVP_DIR eDir );
-
-  Void          deriveRightBottomIdx        ( UInt uiPartIdx, UInt& ruiPartIdxRB );
-  Bool          xGetColMVP( RefPicList eRefPicList, Int ctuRsAddr, Int uiPartUnitIdx, TComMv& rcMv, Int& riRefIdx );
+  /// adds a single possible motion vector predictor candidate
+  Bool          xAddMVPCandUnscaled           ( AMVPInfo &info, const RefPicList eRefPicList, const Int iRefIdx, const UInt uiPartUnitIdx, const MVP_DIR eDir ) const;
+  Bool          xAddMVPCandWithScaling        ( AMVPInfo &info, const RefPicList eRefPicList, const Int iRefIdx, const UInt uiPartUnitIdx, const MVP_DIR eDir ) const;
+
+  Void          deriveRightBottomIdx          ( UInt uiPartIdx, UInt& ruiPartIdxRB ) const;
+  Bool          xGetColMVP                    ( const RefPicList eRefPicList, const Int ctuRsAddr, const Int partUnitIdx, TComMv& rcMv, const Int refIdx ) const;
 
   /// compute scaling factor from POC difference
-  Int           xGetDistScaleFactor   ( Int iCurrPOC, Int iCurrRefPOC, Int iColPOC, Int iColRefPOC );
-
-  Void xDeriveCenterIdx( UInt uiPartIdx, UInt& ruiPartIdxCenter );
+  static Int    xGetDistScaleFactor           ( Int iCurrPOC, Int iCurrRefPOC, Int iColPOC, Int iColRefPOC );
+
+  Void          xDeriveCenterIdx              ( UInt uiPartIdx, UInt& ruiPartIdxCenter ) const;
 
 public:
-  TComDataCU();
-  virtual ~TComDataCU();
+                TComDataCU();
+  virtual       ~TComDataCU();
 
   // -------------------------------------------------------------------------------------------------------------------
@@ -181,21 +181,21 @@
   // -------------------------------------------------------------------------------------------------------------------
 
-  Void          create                ( ChromaFormat chromaFormatIDC, UInt uiNumPartition, UInt uiWidth, UInt uiHeight, Bool bDecSubCu, Int unitSize
+  Void          create                        ( ChromaFormat chromaFormatIDC, UInt uiNumPartition, UInt uiWidth, UInt uiHeight, Bool bDecSubCu, Int unitSize
 #if ADAPTIVE_QP_SELECTION
-    , TCoeff *pParentARLBuffer = 0
-#endif
-    );
-  Void          destroy               ();
-
-  Void          initCtu               ( TComPic* pcPic, UInt ctuRsAddr );
-  Void          initEstData           ( const UInt uiDepth, const Int qp, const Bool bTransquantBypass );
-  Void          initSubCU             ( TComDataCU* pcCU, UInt uiPartUnitIdx, UInt uiDepth, Int qp );
-  Void          setOutsideCUPart      ( UInt uiAbsPartIdx, UInt uiDepth );
-
-  Void          copySubCU             ( TComDataCU* pcCU, UInt uiPartUnitIdx );
-  Void          copyInterPredInfoFrom ( TComDataCU* pcCU, UInt uiAbsPartIdx, RefPicList eRefPicList );
-  Void          copyPartFrom          ( TComDataCU* pcCU, UInt uiPartUnitIdx, UInt uiDepth );
-
-  Void          copyToPic             ( UChar uiDepth );
+                                                , TCoeff *pParentARLBuffer = 0
+#endif
+                                              );
+  Void          destroy                       ( );
+
+  Void          initCtu                       ( TComPic* pcPic, UInt ctuRsAddr );
+  Void          initEstData                   ( const UInt uiDepth, const Int qp, const Bool bTransquantBypass );
+  Void          initSubCU                     ( TComDataCU* pcCU, UInt uiPartUnitIdx, UInt uiDepth, Int qp );
+  Void          setOutsideCUPart              ( UInt uiAbsPartIdx, UInt uiDepth );
+
+  Void          copySubCU                     ( TComDataCU* pcCU, UInt uiPartUnitIdx );
+  Void          copyInterPredInfoFrom         ( TComDataCU* pcCU, UInt uiAbsPartIdx, RefPicList eRefPicList );
+  Void          copyPartFrom                  ( TComDataCU* pcCU, UInt uiPartUnitIdx, UInt uiDepth );
+
+  Void          copyToPic                     ( UChar uiDepth );
 
   // -------------------------------------------------------------------------------------------------------------------
@@ -203,19 +203,19 @@
   // -------------------------------------------------------------------------------------------------------------------
 
-  TComPic*        getPic              ()                        { return m_pcPic;           }
-  const TComPic*  getPic              () const                  { return m_pcPic;           }
-  TComSlice*       getSlice           ()                        { return m_pcSlice;         }
-  const TComSlice* getSlice           () const                  { return m_pcSlice;         }
-  UInt&         getCtuRsAddr          ()                        { return m_ctuRsAddr;       }
-  UInt          getCtuRsAddr          () const                  { return m_ctuRsAddr;       }
-  UInt          getZorderIdxInCtu     () const                  { return m_absZIdxInCtu;    }
-  UInt          getCUPelX             () const                  { return m_uiCUPelX;        }
-  UInt          getCUPelY             () const                  { return m_uiCUPelY;        }
-
-  UChar*        getDepth              ()                        { return m_puhDepth;        }
-  UChar         getDepth              ( UInt uiIdx ) const      { return m_puhDepth[uiIdx]; }
-  Void          setDepth              ( UInt uiIdx, UChar  uh ) { m_puhDepth[uiIdx] = uh;   }
-
-  Void          setDepthSubParts      ( UInt uiDepth, UInt uiAbsPartIdx );
+  TComPic*         getPic                     ( )                                                          { return m_pcPic;                            }
+  const TComPic*   getPic                     ( ) const                                                    { return m_pcPic;                            }
+  TComSlice*       getSlice                   ( )                                                          { return m_pcSlice;                          }
+  const TComSlice* getSlice                   ( ) const                                                    { return m_pcSlice;                          }
+  UInt&         getCtuRsAddr                  ( )                                                          { return m_ctuRsAddr;                        }
+  UInt          getCtuRsAddr                  ( ) const                                                    { return m_ctuRsAddr;                        }
+  UInt          getZorderIdxInCtu             ( ) const                                                    { return m_absZIdxInCtu;                     }
+  UInt          getCUPelX                     ( ) const                                                    { return m_uiCUPelX;                         }
+  UInt          getCUPelY                     ( ) const                                                    { return m_uiCUPelY;                         }
+
+  UChar*        getDepth                      ( )                                                          { return m_puhDepth;                         }
+  UChar         getDepth                      ( UInt uiIdx ) const                                         { return m_puhDepth[uiIdx];                  }
+  Void          setDepth                      ( UInt uiIdx, UChar uh )                                     { m_puhDepth[uiIdx] = uh;                    }
+
+  Void          setDepthSubParts              ( UInt uiDepth, UInt uiAbsPartIdx );
 
   // -------------------------------------------------------------------------------------------------------------------
